<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>com.partisiablockchain.language</groupId>
  <artifactId>partisia-cli</artifactId>
  <packaging>jar</packaging>
  <version>5.162.0</version>

  <licenses>
    <license>
      <name>AGPL-3.0-or-later</name>
      <url>https://www.gnu.org/licenses/agpl.txt</url>
      <distribution>repo</distribution>
    </license>
  </licenses>

  <repositories>
    <repository>
      <id>gitlab-partisiablockchain</id>
      <url>https://gitlab.com/api/v4/groups/12499775/-/packages/maven/</url>
    </repository>
  </repositories>

  <pluginRepositories>
    <pluginRepository>
      <id>gitlab-partisiablockchain</id>
      <url>https://gitlab.com/api/v4/groups/12499775/-/packages/maven/</url>
    </pluginRepository>
  </pluginRepositories>

  <parent>
    <groupId>com.partisiablockchain</groupId>
    <artifactId>pom</artifactId>
    <version>4.110.0</version>
  </parent>

  <dependencies>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>sections</artifactId>
      <version>5.37.0</version>
    </dependency>
    <dependency>
      <groupId>com.secata.tools</groupId>
      <artifactId>coverage</artifactId>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.core</groupId>
      <artifactId>server</artifactId>
      <version>5.79.0</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.core</groupId>
      <artifactId>client</artifactId>
      <version>5.33.0</version>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>codegen-lib</artifactId>
      <version>5.110.0</version>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>abi-codegen</artifactId>
      <version>5.110.0</version>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>contract-standard</artifactId>
      <version>5.110.0</version>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>deployment-client</artifactId>
      <version>5.110.0</version>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>zk-client</artifactId>
      <version>5.127.0</version>
    </dependency>
    <dependency>
      <groupId>info.picocli</groupId>
      <artifactId>picocli</artifactId>
      <version>4.7.3</version>
    </dependency>
    <dependency>
      <groupId>ch.qos.logback</groupId>
      <artifactId>logback-classic</artifactId>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>record-replay-client</artifactId>
      <version>5.50.0</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>com.partisiablockchain.language</groupId>
      <artifactId>sections</artifactId>
      <version>5.37.0</version>
      <exclusions>
        <exclusion>
          <groupId>com.partisiablockchain.core</groupId>
          <artifactId>contract</artifactId>
        </exclusion>
      </exclusions>
    </dependency>
  </dependencies>

  <build>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-compiler-plugin</artifactId>
        <!-- annotationProcessorPaths requires maven-compiler-plugin version 3.5 or higher -->
        <version>3.11.0</version>
        <executions>
          <execution>
            <id>default-compile</id>
            <configuration>
              <annotationProcessorPaths>
                <path>
                  <groupId>info.picocli</groupId>
                  <artifactId>picocli-codegen</artifactId>
                  <version>4.7.1</version>
                </path>
              </annotationProcessorPaths>
              <compilerArgs>
                <arg>-Aproject=${project.groupId}/${project.artifactId}</arg>
              </compilerArgs>
            </configuration>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-assembly-plugin</artifactId>
        <version>3.6.0</version>
        <configuration>
          <archive>
            <manifest>
              <mainClass>com.partisiablockchain.language.partisiacli.Main</mainClass>
            </manifest>
          </archive>
          <descriptors>
            <descriptor>src/main/assembly/jar-with-dependencies-and-services.xml</descriptor>
          </descriptors>
        </configuration>
        <executions>
          <execution>
            <id>make-assembly</id>
            <phase>package</phase>
            <goals>
              <goal>single</goal>
            </goals>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>build-helper-maven-plugin</artifactId>
        <version>3.6.0</version>
        <executions>
          <execution>
            <id>Add ABI generated code to sources</id>
            <phase>generate-sources</phase>
            <goals>
              <goal>add-source</goal>
            </goals>
            <configuration>
              <sources>
                <source>${project.basedir}/target/generated-sources/generated-abi</source>
              </sources>
            </configuration>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
        <version>3.5.0</version>
        <configuration>
          <excludePackageNames>com.partisiablockchain.language.abicodegen</excludePackageNames>
        </configuration>
      </plugin>
    </plugins>
  </build>

  <properties>
    <maven.compiler.source>17</maven.compiler.source>
    <maven.compiler.target>17</maven.compiler.target>
    <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
  </properties>
</project>
